3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
20 die "Usage: $0 $USAGE"
24 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
26 GIT_REFLOG_ACTION="$*"
27 export GIT_REFLOG_ACTION
31 is_bare_repository () {
32 git-config --bool --get core.bare ||
34 .git | */.git) echo false ;;
40 cdup=$(git-rev-parse --show-cdup)
44 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
50 require_work_tree () {
51 test $(is_bare_repository) = false &&
52 test $(git-rev-parse --is-inside-git-dir) = false ||
53 die "fatal: $0 cannot be used without a working tree."
56 if [ -z "$LONG_USAGE" ]
58 LONG_USAGE="Usage: $0 $USAGE"
60 LONG_USAGE="Usage: $0 $USAGE
66 -h|--h|--he|--hel|--help)
71 # Make sure we are in a valid repository of a vintage we understand.
72 if [ -z "$SUBDIRECTORY_OK" ]
75 GIT_DIR=$(GIT_DIR="$GIT_DIR" git-rev-parse --git-dir) || {
77 echo >&2 "You need to run this command from the toplevel of the working tree."
81 GIT_DIR=$(git-rev-parse --git-dir) || exit
83 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}